import { DeepPartial, MaybePromise } from '@ts-phoenix/typings';
import { Core } from './core';
import { PackagesConstructors, PartialConfig, ServiceIdentifier } from './defs';
export declare abstract class Package<FullConfigType extends Record<string, any> | null = null, RequiredConfigType extends Partial<FullConfigType> | null = null> {
    protected core: Core;
    private _config;
    constructor(...args: RequiredConfigType extends null ? [DeepPartial<FullConfigType>?] : [RequiredConfigType & DeepPartial<FullConfigType>]);
    getDependencies(): PackagesConstructors;
    getDefaultConfig(): PartialConfig<FullConfigType, RequiredConfigType>;
    initialise(): MaybePromise<void>;
    bind(): MaybePromise<void>;
    get config(): FullConfigType;
    private __setCore;
    private __mergeConfig;
    protected bindConfig(token: ServiceIdentifier<FullConfigType>): void;
}
