"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Package = void 0;
const utils_1 = require("@ts-phoenix/utils");
class Package {
    constructor(...args) {
        this._config = (this.getDefaultConfig() || {});
        if (args[0]) {
            this.__mergeConfig(args[0]);
        }
    }
    getDependencies() {
        return [];
    }
    getDefaultConfig() {
        return null;
    }
    initialise() {
        return;
    }
    bind() {
        return;
    }
    get config() {
        return this._config;
    }
    __setCore(core) {
        this.core = core;
    }
    __mergeConfig(config) {
        if (this.config == null) {
            this._config = { ...config };
            return;
        }
        (0, utils_1.mergeDeep)({
            target: this._config,
            sources: [config, this._config],
        });
    }
    bindConfig(token) {
        this.core.container.bind(token).toConstantValue(this.config);
    }
}
exports.Package = Package;
